
package hotTip;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.JPasswordField;
import java.io.*;
import java.net.*;
import java.util.*;

import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;

import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

public class AuthorityServer implements ActionListener {

    JFrame converterFrame;
    JPanel converterPanel;

    JPasswordField sharedPwd; /* what server/authority shares with Broker */
    JPasswordField adminPwd;  /* used to encrypt uname/pwd file */

    JTextField port;          /* that server will listen on */

    JLabel sharedPwdLabel;
    JLabel adminPwdLabel;
    JLabel portLabel;

    JLabel working;
    JButton submit;
    
    Font font;

    Socket serverSocket = null; // to talk to client on
    PrintWriter out = null;     // what write to client with
    BufferedReader in = null;   // what read from client with

    boolean listening = true;
    
    public AuthorityServer() {

        //Create and set up the window.
        converterFrame = new JFrame("Login...");
        converterFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        converterFrame.setSize(new Dimension(120, 40));

        //Create and set up the panel.
        converterPanel = new JPanel(new GridLayout(2, 2));

        //Add the widgets.
        addWidgets();

        //Set the default button.
        converterFrame.getRootPane().setDefaultButton(submit);

        //Add the panel to the window.
        converterFrame.getContentPane().add(converterPanel, BorderLayout.CENTER);

        //Display the window.
        converterFrame.pack();
        converterFrame.setVisible(true);
    }

    /**
     * Create and add the widgets.
     *
     */
    private void addWidgets() {

        //Create widgets.

        sharedPwd = new JPasswordField(2);
        sharedPwd.setEchoChar('#'); 

	adminPwd = new JPasswordField(2);
	adminPwd.setEchoChar('#');

	port = new JTextField(2);

        sharedPwdLabel = new JLabel("Password Shared with Broker", SwingConstants.LEFT);
        sharedPwdLabel.setLabelFor(sharedPwd);

	adminPwdLabel = new JLabel("Admin password (used for encrypting	file)",
				   SwingConstants.LEFT);
	sharedPwdLabel.setLabelFor(adminPwd);

	portLabel = new JLabel("port number for server to listen on",SwingConstants.LEFT);
	portLabel.setLabelFor(port);

        working = new JLabel("Working.........", SwingConstants.CENTER);

        font = new Font("Dialog",java.awt.Font.BOLD,48);
        working.setFont(font);

        submit = new JButton("Submit");        

        //Listen to events from the Submit button.
        submit.addActionListener(this);

        //Add the widgets to the container.
        converterPanel.add(sharedPwdLabel);
        converterPanel.add(sharedPwd);
        
        converterPanel.add(adminPwdLabel);
        converterPanel.add(adminPwd);
        
        converterPanel.add(portLabel);
        converterPanel.add(port);

        converterPanel.add(submit);

        sharedPwdLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

        adminPwdLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

        portLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
    }   

    public void actionPerformed(ActionEvent event) {

	ServerSocket serverSocket = null;

	/* generate new server socket */
        try {
            serverSocket = new ServerSocket(Integer.parseInt(port.getText())); } 

	catch (IOException e) {
            System.err.println("Could not listen on port: " + port.getText());
            System.exit(1); }

        Socket clientSocket = null;

	while( listening ) {

	    /* get client sock */
	    try {
		clientSocket = serverSocket.accept(); }         

	    catch (IOException e) {
		System.err.println("Accept failed.");
		System.exit(1); }       

	    /* spawn new thread to handle that client sock */
	    new AuthorityServerThread( clientSocket,
				       adminPwd.getPassword(),
				       sharedPwd.getPassword() ).start();

	}

	try {
	    serverSocket.close(); }

	catch( IOException iox ) {
	    System.out.println(iox.getMessage());
	    iox.printStackTrace();	    
	}
	
	System.exit(0);
    }

 
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);
	
        AuthorityServer converter = new AuthorityServer();
    }


    public static void main(String[] args) throws IOException {

	//Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
		public void run() {
		    createAndShowGUI();
		}
	    });	
    }
}
